;;; ----------------
;;; Ordinal ordering
;;; ----------------

(in-package "ACL2")

;;; The ordinal ordering is a partial strict order.

(defthm |~(a <e0 a)|
  (not (e0-ord-< a a)))

(defthm |a <e0 b & b <e0 c => a <e0 c|
  (implies (and (e0-ord-< a b) (e0-ord-< b c)) (e0-ord-< a c)))

;;; Antisymmetry of the ordinal ordering.

(defthm |a <e0 b => ~(b <e0 a)|
  (implies (e0-ord-< a b)
           (not (e0-ord-< b a)))
  :hints (("Goal"
	   :in-theory (disable |a <e0 b & b <e0 c => a <e0 c|)
	   :use (:instance |a <e0 b & b <e0 c => a <e0 c| (c a)))))
